﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YSocket.AsyncSocket;
using System.Threading;
using YSocket;
namespace SocketTest
{
    public partial class Form1 : Form
    {
        SynchronizationContext _uiContext;
        YunAsyncServerSocket _server;
        public Form1()
        {
            InitializeComponent();

            _uiContext = SynchronizationContext.Current;
            UControlSetup();
            UControlAction();
        }

        private void UControlAction()
        {
            button1.Click += 서버시작;
            button2.Click += 서버종료;
            button3.Click += 클라이언트시작;
        }

        private void 클라이언트시작(object sender, EventArgs e)
        {
            Form2 frm = new Form2();
            frm.Show();
        }

        private void 서버종료(object sender, EventArgs e)
        {
            
        }

        private void 서버시작(object sender, EventArgs e)
        {
            _server= YunAsyncSocketFactory.SetupServer(Yun통신규약.사용포트a);
            _server.ActSysMessage += (args) => {

                _uiContext.Post(a => { richTextBox1.AppendText(args); }, null);
            };
            _server.ActReceiveMessage += (args) => {

                _uiContext.Post(a => { richTextBox2.AppendText(args); }, null);
            };
            _server.Start();
        }

        private void UControlSetup()
        {
            button1.Text = "start";
            button2.Text = "end";
            button3.Text = "Client";
        }
    }
}
