﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Sockets;
using YSocket;
namespace YSocket.AsyncSocket
{
    [Serializable]
    public abstract  class YunAsyncCommon
    {
        protected static readonly Object _lock = new object();

        public IPEndPoint LocalSocketIpEndPoint { get; set; }
        public Socket LocalSocket { get; set; }

        public Yun통신규약 Yun통신규약 { get; set; }

        public Action<string> ActSysMessage;
        public Action<string> ActSendMessage;
        public Action<byte[]> ActSendData;

        public Action<byte[]> ActReceiveData;
        public Action<string> ActReceiveMessage;

        public string Nm { get; set; }
        public abstract void MkNm();
        public virtual bool CheckSocketStart()
        {
            if (LocalSocketIpEndPoint == null) return false;
            if (Yun통신규약 == null) return false;
            MkNm();
       
            return true;
        }
        public Socket GetTcpSocket()
        {
            return new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        }
    }
}
