﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Sockets;
using YSocket;
using YSocket.Util;
namespace YSocket.AsyncSocket
{
    public class YunAsyncSocketFactory
    {
        public static  YunAsyncServerSocket SetupServer(int port)
        {
            YunAsyncServerSocket socket = new YunAsyncServerSocket();
            IPAddress ip = YunNetAddresHelper.GetLocalIPAddress();
            socket.LocalSocketIpEndPoint = new IPEndPoint(ip, port);
            Yun통신규약 통신규약 = new Yun통신규약()
            {
                HeaderSize = 4,
                SocketBufferSize = 1024
            };
            socket.Yun통신규약 = 통신규약;
            return socket;
        }

        public static YunAsyncClientSocket SetupClient(int port)
        {
            YunAsyncClientSocket socket = new YunAsyncClientSocket();
            IPAddress ip = YunNetAddresHelper.GetLocalIPAddress();
            socket.LocalSocketIpEndPoint = new IPEndPoint(ip, port);
            Yun통신규약 통신규약 = new Yun통신규약()
            {
                HeaderSize = 4,
                SocketBufferSize = 1024
            };
            socket.Yun통신규약 = 통신규약;
            return socket;

        }
    }
}
