﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YSocket.AsyncSocket;
using YSocket.Util;
using YSocket;
using System.Threading;
namespace SocketTest
{
    public partial class Form2 : Form
    {
        SynchronizationContext _uiContext;
        YunAsyncClientSocket _client;
        public Form2()
        {
            InitializeComponent();
            UControlSetting();
            UControlAction();
        }

        private void UControlSetting()
        {
            _uiContext = SynchronizationContext.Current;
            button1.Text = "접속";
            button2.Text = "종료";
        }

        private void UControlAction()
        {
            button1.Click += 접속;
            button2.Click += 종료;
            textBox1.KeyDown += 메시지전송;
        }

        private void 메시지전송(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Return)
            {
                _client.ActSendMessage(textBox1.Text);
            }
        }

        private void 종료(object sender, EventArgs e)
        {
            _client.Close();
        }

        private void 접속(object sender, EventArgs e)
        {
            _client = YunAsyncSocketFactory.SetupClient(Yun통신규약.사용포트a);
            _client.ActSysMessage += (args) => {
                _uiContext.Post(a => richTextBox1.AppendText(args), null);
            };
            _client.ActReceiveMessage += (args) => {
                _uiContext.Post(a => richTextBox2.AppendText(args), null);
            };
            
            _client.Connect();
        }
    }
}
